# See LICENSE for license details.

#*****************************************************************************
# vsetcfgi.S
#-----------------------------------------------------------------------------
#
# Test vsetcfg instruction with immediates.
#

#include "riscv_test.h"
#include "test_macros.h"

RVTEST_RV64UV
RVTEST_CODE_BEGIN

  #-------------------------------------------------------------
  # Arithmetic tests
  #-------------------------------------------------------------

  #TEST_VSETCFGIVL( 2, 0, 0, 0xf8, 768, 768 );
  #TEST_VSETCFGIVL( 3, 0, 0, 0xf8, 769, 768 );
  #TEST_VSETCFGIVL( 4, 0, 0, 0xf8, 767, 767 );

  TEST_VSETCFGIVL( 5, 0, 0, 0x00, 2048, 2048 );
  TEST_VSETCFGIVL( 6, 0, 0, 0x00, 2049, 2048 );
  TEST_VSETCFGIVL( 7, 0, 0, 0x00, 2047, 2047 );

  #TEST_VSETCFGIVL( 8, 1, 0, 0xf8, 768, 768 );
  #TEST_VSETCFGIVL( 9, 1, 0, 0xf8, 769, 768 );
  #TEST_VSETCFGIVL( 10, 1, 0, 0xf8, 767, 767 );

  TEST_VSETCFGIVL( 11, 1, 0, 0x00, 2048, 2048 );
  TEST_VSETCFGIVL( 12, 1, 0, 0x00, 2049, 2048 );
  TEST_VSETCFGIVL( 13, 1, 0, 0x00, 2047, 2047 );

  #TEST_VSETCFGIVL( 14, 2, 0, 0xf8, 768, 768 );
  #TEST_VSETCFGIVL( 15, 2, 0, 0xf8, 769, 768 );
  #TEST_VSETCFGIVL( 16, 2, 0, 0xf8, 767, 767 );

  TEST_VSETCFGIVL( 17, 2, 0, 0x00, 2048, 2048 );
  TEST_VSETCFGIVL( 18, 2, 0, 0x00, 2049, 2048 );
  TEST_VSETCFGIVL( 19, 2, 0, 0x00, 2047, 2047 );

  #TEST_VSETCFGIVL( 20, 3, 0, 0xf8, 384, 384 );
  #TEST_VSETCFGIVL( 21, 3, 0, 0xf8, 385, 384 );
  #TEST_VSETCFGIVL( 22, 3, 0, 0xf8, 383, 383 );

  TEST_VSETCFGIVL( 23, 3, 0, 0x00, 1024, 1024 );
  TEST_VSETCFGIVL( 24, 3, 0, 0x00, 1025, 1024 );
  TEST_VSETCFGIVL( 25, 3, 0, 0x00, 1023, 1023 );

  #TEST_VSETCFGIVL( 26, 4, 0, 0xf8, 255, 255 );
  #TEST_VSETCFGIVL( 27, 4, 0, 0xf8, 256, 255 );
  #TEST_VSETCFGIVL( 28, 4, 0, 0xf8, 254, 254 );

  TEST_VSETCFGIVL( 29, 4, 0, 0x00, 680, 680 );
  TEST_VSETCFGIVL( 30, 4, 0, 0x00, 681, 680 );
  TEST_VSETCFGIVL( 31, 4, 0, 0x00, 679, 679 );

  #TEST_VSETCFGIVL( 32, 5, 0, 0xf8, 192, 192 );
  #TEST_VSETCFGIVL( 33, 5, 0, 0xf8, 193, 192 );
  #TEST_VSETCFGIVL( 34, 5, 0, 0xf8, 191, 191 );

  TEST_VSETCFGIVL( 35, 5, 0, 0x00, 512, 512 );
  TEST_VSETCFGIVL( 36, 5, 0, 0x00, 513, 512 );
  TEST_VSETCFGIVL( 37, 5, 0, 0x00, 511, 511 );

  #TEST_VSETCFGIVL( 38, 6, 0, 0xf8, 153, 153 );
  #TEST_VSETCFGIVL( 39, 6, 0, 0xf8, 154, 153 );
  #TEST_VSETCFGIVL( 40, 6, 0, 0xf8, 152, 152 );

  TEST_VSETCFGIVL( 41, 6, 0, 0x00, 408, 408 );
  TEST_VSETCFGIVL( 42, 6, 0, 0x00, 409, 408 );
  TEST_VSETCFGIVL( 43, 6, 0, 0x00, 407, 407 );

  #TEST_VSETCFGIVL( 44, 7, 0, 0xf8, 126, 126 );
  #TEST_VSETCFGIVL( 45, 7, 0, 0xf8, 127, 126 );
  #TEST_VSETCFGIVL( 46, 7, 0, 0xf8, 125, 125 );

  TEST_VSETCFGIVL( 47, 7, 0, 0x00, 336, 336 );
  TEST_VSETCFGIVL( 48, 7, 0, 0x00, 337, 336 );
  TEST_VSETCFGIVL( 49, 7, 0, 0x00, 335, 335 );

  #TEST_VSETCFGIVL( 50, 8, 0, 0xf8, 108, 108 );
  #TEST_VSETCFGIVL( 51, 8, 0, 0xf8, 109, 108 );
  #TEST_VSETCFGIVL( 52, 8, 0, 0xf8, 107, 107 );

  TEST_VSETCFGIVL( 53, 8, 0, 0x00, 288, 288 );
  TEST_VSETCFGIVL( 54, 8, 0, 0x00, 289, 288 );
  TEST_VSETCFGIVL( 55, 8, 0, 0x00, 287, 287 );

  #TEST_VSETCFGIVL( 56, 9, 0, 0xf8, 96, 96 );
  #TEST_VSETCFGIVL( 57, 9, 0, 0xf8, 97, 96 );
  #TEST_VSETCFGIVL( 58, 9, 0, 0xf8, 95, 95 );

  TEST_VSETCFGIVL( 59, 9, 0, 0x00, 256, 256 );
  TEST_VSETCFGIVL( 60, 9, 0, 0x00, 257, 256 );
  TEST_VSETCFGIVL( 61, 9, 0, 0x00, 255, 255 );

  #TEST_VSETCFGIVL( 62, 10, 0, 0xf8, 84, 84 );
  #TEST_VSETCFGIVL( 63, 10, 0, 0xf8, 85, 84 );
  #TEST_VSETCFGIVL( 64, 10, 0, 0xf8, 83, 83 );

  TEST_VSETCFGIVL( 65, 10, 0, 0x00, 224, 224 );
  TEST_VSETCFGIVL( 66, 10, 0, 0x00, 225, 224 );
  TEST_VSETCFGIVL( 67, 10, 0, 0x00, 223, 223 );

  #TEST_VSETCFGIVL( 68, 11, 0, 0xf8, 75, 75 );
  #TEST_VSETCFGIVL( 69, 11, 0, 0xf8, 76, 75 );
  #TEST_VSETCFGIVL( 70, 11, 0, 0xf8, 74, 74 );

  TEST_VSETCFGIVL( 71, 11, 0, 0x00, 200, 200 );
  TEST_VSETCFGIVL( 72, 11, 0, 0x00, 201, 200 );
  TEST_VSETCFGIVL( 73, 11, 0, 0x00, 199, 199 );

  #TEST_VSETCFGIVL( 74, 12, 0, 0xf8, 69, 69 );
  #TEST_VSETCFGIVL( 75, 12, 0, 0xf8, 70, 69 );
  #TEST_VSETCFGIVL( 76, 12, 0, 0xf8, 68, 68 );

  TEST_VSETCFGIVL( 77, 12, 0, 0x00, 184, 184 );
  TEST_VSETCFGIVL( 78, 12, 0, 0x00, 185, 184 );
  TEST_VSETCFGIVL( 79, 12, 0, 0x00, 183, 183 );

  #TEST_VSETCFGIVL( 80, 13, 0, 0xf8, 63, 63 );
  #TEST_VSETCFGIVL( 81, 13, 0, 0xf8, 64, 63 );
  #TEST_VSETCFGIVL( 82, 13, 0, 0xf8, 62, 62 );

  TEST_VSETCFGIVL( 83, 13, 0, 0x00, 168, 168 );
  TEST_VSETCFGIVL( 84, 13, 0, 0x00, 169, 168 );
  TEST_VSETCFGIVL( 85, 13, 0, 0x00, 167, 167 );

  #TEST_VSETCFGIVL( 86, 14, 0, 0xf8, 57, 57 );
  #TEST_VSETCFGIVL( 87, 14, 0, 0xf8, 58, 57 );
  #TEST_VSETCFGIVL( 88, 14, 0, 0xf8, 56, 56 );

  TEST_VSETCFGIVL( 89, 14, 0, 0x00, 152, 152 );
  TEST_VSETCFGIVL( 90, 14, 0, 0x00, 153, 152 );
  TEST_VSETCFGIVL( 91, 14, 0, 0x00, 151, 151 );

  #TEST_VSETCFGIVL( 92, 15, 0, 0xf8, 54, 54 );
  #TEST_VSETCFGIVL( 93, 15, 0, 0xf8, 55, 54 );
  #TEST_VSETCFGIVL( 94, 15, 0, 0xf8, 53, 53 );

  TEST_VSETCFGIVL( 95, 15, 0, 0x00, 144, 144 );
  TEST_VSETCFGIVL( 96, 15, 0, 0x00, 145, 144 );
  TEST_VSETCFGIVL( 97, 15, 0, 0x00, 143, 143 );

  #TEST_VSETCFGIVL( 98, 16, 0, 0xf8, 51, 51 );
  #TEST_VSETCFGIVL( 99, 16, 0, 0xf8, 52, 51 );
  #TEST_VSETCFGIVL( 100, 16, 0, 0xf8, 50, 50 );

  TEST_VSETCFGIVL( 101, 16, 0, 0x00, 136, 136 );
  TEST_VSETCFGIVL( 102, 16, 0, 0x00, 137, 136 );
  TEST_VSETCFGIVL( 103, 16, 0, 0x00, 135, 135 );

  #TEST_VSETCFGIVL( 104, 17, 0, 0xf8, 48, 48 );
  #TEST_VSETCFGIVL( 105, 17, 0, 0xf8, 49, 48 );
  #TEST_VSETCFGIVL( 106, 17, 0, 0xf8, 47, 47 );

  TEST_VSETCFGIVL( 107, 17, 0, 0x00, 128, 128 );
  TEST_VSETCFGIVL( 108, 17, 0, 0x00, 129, 128 );
  TEST_VSETCFGIVL( 109, 17, 0, 0x00, 127, 127 );

  #TEST_VSETCFGIVL( 110, 18, 0, 0xf8, 45, 45 );
  #TEST_VSETCFGIVL( 111, 18, 0, 0xf8, 46, 45 );
  #TEST_VSETCFGIVL( 112, 18, 0, 0xf8, 44, 44 );

  TEST_VSETCFGIVL( 113, 18, 0, 0x00, 120, 120 );
  TEST_VSETCFGIVL( 114, 18, 0, 0x00, 121, 120 );
  TEST_VSETCFGIVL( 115, 18, 0, 0x00, 119, 119 );

  #TEST_VSETCFGIVL( 116, 19, 0, 0xf8, 42, 42 );
  #TEST_VSETCFGIVL( 117, 19, 0, 0xf8, 43, 42 );
  #TEST_VSETCFGIVL( 118, 19, 0, 0xf8, 41, 41 );

  TEST_VSETCFGIVL( 119, 19, 0, 0x00, 112, 112 );
  TEST_VSETCFGIVL( 120, 19, 0, 0x00, 113, 112 );
  TEST_VSETCFGIVL( 121, 19, 0, 0x00, 111, 111 );

  #TEST_VSETCFGIVL( 122, 20, 0, 0xf8, 39, 39 );
  #TEST_VSETCFGIVL( 123, 20, 0, 0xf8, 40, 39 );
  #TEST_VSETCFGIVL( 124, 20, 0, 0xf8, 38, 38 );

  TEST_VSETCFGIVL( 125, 20, 0, 0x00, 104, 104 );
  TEST_VSETCFGIVL( 126, 20, 0, 0x00, 105, 104 );
  TEST_VSETCFGIVL( 127, 20, 0, 0x00, 103, 103 );

  #TEST_VSETCFGIVL( 128, 21, 0, 0xf8, 36, 36 );
  #TEST_VSETCFGIVL( 129, 21, 0, 0xf8, 37, 36 );
  #TEST_VSETCFGIVL( 130, 21, 0, 0xf8, 35, 35 );

  TEST_VSETCFGIVL( 131, 21, 0, 0x00, 96, 96 );
  TEST_VSETCFGIVL( 132, 21, 0, 0x00, 97, 96 );
  TEST_VSETCFGIVL( 133, 21, 0, 0x00, 95, 95 );

  #TEST_VSETCFGIVL( 134, 22, 0, 0xf8, 36, 36 );
  #TEST_VSETCFGIVL( 135, 22, 0, 0xf8, 37, 36 );
  #TEST_VSETCFGIVL( 136, 22, 0, 0xf8, 35, 35 );

  TEST_VSETCFGIVL( 137, 22, 0, 0x00, 96, 96 );
  TEST_VSETCFGIVL( 138, 22, 0, 0x00, 97, 96 );
  TEST_VSETCFGIVL( 139, 22, 0, 0x00, 95, 95 );

  #TEST_VSETCFGIVL( 140, 23, 0, 0xf8, 33, 33 );
  #TEST_VSETCFGIVL( 141, 23, 0, 0xf8, 34, 33 );
  #TEST_VSETCFGIVL( 142, 23, 0, 0xf8, 32, 32 );

  TEST_VSETCFGIVL( 143, 23, 0, 0x00, 88, 88 );
  TEST_VSETCFGIVL( 144, 23, 0, 0x00, 89, 88 );
  TEST_VSETCFGIVL( 145, 23, 0, 0x00, 87, 87 );

  #TEST_VSETCFGIVL( 146, 24, 0, 0xf8, 33, 33 );
  #TEST_VSETCFGIVL( 147, 24, 0, 0xf8, 34, 33 );
  #TEST_VSETCFGIVL( 148, 24, 0, 0xf8, 32, 32 );

  TEST_VSETCFGIVL( 149, 24, 0, 0x00, 88, 88 );
  TEST_VSETCFGIVL( 150, 24, 0, 0x00, 89, 88 );
  TEST_VSETCFGIVL( 151, 24, 0, 0x00, 87, 87 );

  #TEST_VSETCFGIVL( 152, 25, 0, 0xf8, 30, 30 );
  #TEST_VSETCFGIVL( 153, 25, 0, 0xf8, 31, 30 );
  #TEST_VSETCFGIVL( 154, 25, 0, 0xf8, 29, 29 );

  TEST_VSETCFGIVL( 155, 25, 0, 0x00, 80, 80 );
  TEST_VSETCFGIVL( 156, 25, 0, 0x00, 81, 80 );
  TEST_VSETCFGIVL( 157, 25, 0, 0x00, 79, 79 );

  #TEST_VSETCFGIVL( 158, 26, 0, 0xf8, 30, 30 );
  #TEST_VSETCFGIVL( 159, 26, 0, 0xf8, 31, 30 );
  #TEST_VSETCFGIVL( 160, 26, 0, 0xf8, 29, 29 );

  TEST_VSETCFGIVL( 161, 26, 0, 0x00, 80, 80 );
  TEST_VSETCFGIVL( 162, 26, 0, 0x00, 81, 80 );
  TEST_VSETCFGIVL( 163, 26, 0, 0x00, 79, 79 );

  #TEST_VSETCFGIVL( 164, 27, 0, 0xf8, 27, 27 );
  #TEST_VSETCFGIVL( 165, 27, 0, 0xf8, 28, 27 );
  #TEST_VSETCFGIVL( 166, 27, 0, 0xf8, 26, 26 );

  TEST_VSETCFGIVL( 167, 27, 0, 0x00, 72, 72 );
  TEST_VSETCFGIVL( 168, 27, 0, 0x00, 73, 72 );
  TEST_VSETCFGIVL( 169, 27, 0, 0x00, 71, 71 );

  #TEST_VSETCFGIVL( 170, 28, 0, 0xf8, 27, 27 );
  #TEST_VSETCFGIVL( 171, 28, 0, 0xf8, 28, 27 );
  #TEST_VSETCFGIVL( 172, 28, 0, 0xf8, 26, 26 );

  TEST_VSETCFGIVL( 173, 28, 0, 0x00, 72, 72 );
  TEST_VSETCFGIVL( 174, 28, 0, 0x00, 73, 72 );
  TEST_VSETCFGIVL( 175, 28, 0, 0x00, 71, 71 );

  #TEST_VSETCFGIVL( 176, 29, 0, 0xf8, 27, 27 );
  #TEST_VSETCFGIVL( 177, 29, 0, 0xf8, 28, 27 );
  #TEST_VSETCFGIVL( 178, 29, 0, 0xf8, 26, 26 );

  TEST_VSETCFGIVL( 179, 29, 0, 0x00, 72, 72 );
  TEST_VSETCFGIVL( 180, 29, 0, 0x00, 73, 72 );
  TEST_VSETCFGIVL( 181, 29, 0, 0x00, 71, 71 );

  #TEST_VSETCFGIVL( 182, 30, 0, 0xf8, 24, 24 );
  #TEST_VSETCFGIVL( 183, 30, 0, 0xf8, 25, 24 );
  #TEST_VSETCFGIVL( 184, 30, 0, 0xf8, 23, 23 );

  TEST_VSETCFGIVL( 185, 30, 0, 0x00, 64, 64 );
  TEST_VSETCFGIVL( 186, 30, 0, 0x00, 65, 64 );
  TEST_VSETCFGIVL( 187, 30, 0, 0x00, 63, 63 );

  #TEST_VSETCFGIVL( 188, 31, 0, 0xf8, 24, 24 );
  #TEST_VSETCFGIVL( 189, 31, 0, 0xf8, 25, 24 );
  #TEST_VSETCFGIVL( 190, 31, 0, 0xf8, 23, 23 );

  TEST_VSETCFGIVL( 191, 31, 0, 0x00, 64, 64 );
  TEST_VSETCFGIVL( 192, 31, 0, 0x00, 65, 64 );
  TEST_VSETCFGIVL( 193, 31, 0, 0x00, 63, 63 );

  #TEST_VSETCFGIVL( 194, 32, 0, 0xf8, 24, 24 );
  #TEST_VSETCFGIVL( 195, 32, 0, 0xf8, 25, 24 );
  #TEST_VSETCFGIVL( 196, 32, 0, 0xf8, 23, 23 );

  TEST_VSETCFGIVL( 197, 32, 0, 0x00, 64, 64 );
  TEST_VSETCFGIVL( 198, 32, 0, 0x00, 65, 64 );
  TEST_VSETCFGIVL( 199, 32, 0, 0x00, 63, 63 );

  #TEST_VSETCFGIVL( 200, 32, 0, 0xf8, 24, 24 );
  #TEST_VSETCFGIVL( 201, 32, 0, 0xf8, 25, 24 );
  #TEST_VSETCFGIVL( 202, 32, 0, 0xf8, 23, 23 );

  TEST_VSETCFGIVL( 203, 32, 0, 0x00, 64, 64 );
  TEST_VSETCFGIVL( 204, 32, 0, 0x00, 65, 64 );
  TEST_VSETCFGIVL( 205, 32, 0, 0x00, 63, 63 );

  #TEST_VSETCFGIVL( 206, 32, 1, 0xf8, 24, 24 );
  #TEST_VSETCFGIVL( 207, 32, 1, 0xf8, 25, 24 );
  #TEST_VSETCFGIVL( 208, 32, 1, 0xf8, 23, 23 );

  TEST_VSETCFGIVL( 209, 32, 1, 0x00, 64, 64 );
  TEST_VSETCFGIVL( 210, 32, 1, 0x00, 65, 64 );
  TEST_VSETCFGIVL( 211, 32, 1, 0x00, 63, 63 );

  #TEST_VSETCFGIVL( 212, 32, 2, 0xf8, 21, 21 );
  #TEST_VSETCFGIVL( 213, 32, 2, 0xf8, 22, 21 );
  #TEST_VSETCFGIVL( 214, 32, 2, 0xf8, 20, 20 );

  TEST_VSETCFGIVL( 215, 32, 2, 0x00, 56, 56 );
  TEST_VSETCFGIVL( 216, 32, 2, 0x00, 57, 56 );
  TEST_VSETCFGIVL( 217, 32, 2, 0x00, 55, 55 );

  #TEST_VSETCFGIVL( 218, 32, 3, 0xf8, 21, 21 );
  #TEST_VSETCFGIVL( 219, 32, 3, 0xf8, 22, 21 );
  #TEST_VSETCFGIVL( 220, 32, 3, 0xf8, 20, 20 );

  TEST_VSETCFGIVL( 221, 32, 3, 0x00, 56, 56 );
  TEST_VSETCFGIVL( 222, 32, 3, 0x00, 57, 56 );
  TEST_VSETCFGIVL( 223, 32, 3, 0x00, 55, 55 );

  #TEST_VSETCFGIVL( 224, 32, 4, 0xf8, 21, 21 );
  #TEST_VSETCFGIVL( 225, 32, 4, 0xf8, 22, 21 );
  #TEST_VSETCFGIVL( 226, 32, 4, 0xf8, 20, 20 );

  TEST_VSETCFGIVL( 227, 32, 4, 0x00, 56, 56 );
  TEST_VSETCFGIVL( 228, 32, 4, 0x00, 57, 56 );
  TEST_VSETCFGIVL( 229, 32, 4, 0x00, 55, 55 );

  #TEST_VSETCFGIVL( 230, 32, 5, 0xf8, 21, 21 );
  #TEST_VSETCFGIVL( 231, 32, 5, 0xf8, 22, 21 );
  #TEST_VSETCFGIVL( 232, 32, 5, 0xf8, 20, 20 );

  TEST_VSETCFGIVL( 233, 32, 5, 0x00, 56, 56 );
  TEST_VSETCFGIVL( 234, 32, 5, 0x00, 57, 56 );
  TEST_VSETCFGIVL( 235, 32, 5, 0x00, 55, 55 );

  #TEST_VSETCFGIVL( 236, 32, 6, 0xf8, 18, 18 );
  #TEST_VSETCFGIVL( 237, 32, 6, 0xf8, 19, 18 );
  #TEST_VSETCFGIVL( 238, 32, 6, 0xf8, 17, 17 );

  TEST_VSETCFGIVL( 239, 32, 6, 0x00, 48, 48 );
  TEST_VSETCFGIVL( 240, 32, 6, 0x00, 49, 48 );
  TEST_VSETCFGIVL( 241, 32, 6, 0x00, 47, 47 );

  #TEST_VSETCFGIVL( 242, 32, 7, 0xf8, 18, 18 );
  #TEST_VSETCFGIVL( 243, 32, 7, 0xf8, 19, 18 );
  #TEST_VSETCFGIVL( 244, 32, 7, 0xf8, 17, 17 );

  TEST_VSETCFGIVL( 245, 32, 7, 0x00, 48, 48 );
  TEST_VSETCFGIVL( 246, 32, 7, 0x00, 49, 48 );
  TEST_VSETCFGIVL( 247, 32, 7, 0x00, 47, 47 );

  #TEST_VSETCFGIVL( 248, 32, 8, 0xf8, 18, 18 );
  #TEST_VSETCFGIVL( 249, 32, 8, 0xf8, 19, 18 );
  #TEST_VSETCFGIVL( 250, 32, 8, 0xf8, 17, 17 );

  TEST_VSETCFGIVL( 251, 32, 8, 0x00, 48, 48 );
  TEST_VSETCFGIVL( 252, 32, 8, 0x00, 49, 48 );
  TEST_VSETCFGIVL( 253, 32, 8, 0x00, 47, 47 );

  #TEST_VSETCFGIVL( 254, 32, 9, 0xf8, 18, 18 );
  #TEST_VSETCFGIVL( 255, 32, 9, 0xf8, 19, 18 );
  #TEST_VSETCFGIVL( 256, 32, 9, 0xf8, 17, 17 );

  TEST_VSETCFGIVL( 257, 32, 9, 0x00, 48, 48 );
  TEST_VSETCFGIVL( 258, 32, 9, 0x00, 49, 48 );
  TEST_VSETCFGIVL( 259, 32, 9, 0x00, 47, 47 );

  #TEST_VSETCFGIVL( 260, 32, 10, 0xf8, 18, 18 );
  #TEST_VSETCFGIVL( 261, 32, 10, 0xf8, 19, 18 );
  #TEST_VSETCFGIVL( 262, 32, 10, 0xf8, 17, 17 );

  TEST_VSETCFGIVL( 263, 32, 10, 0x00, 48, 48 );
  TEST_VSETCFGIVL( 264, 32, 10, 0x00, 49, 48 );
  TEST_VSETCFGIVL( 265, 32, 10, 0x00, 47, 47 );

  #TEST_VSETCFGIVL( 266, 32, 11, 0xf8, 18, 18 );
  #TEST_VSETCFGIVL( 267, 32, 11, 0xf8, 19, 18 );
  #TEST_VSETCFGIVL( 268, 32, 11, 0xf8, 17, 17 );

  TEST_VSETCFGIVL( 269, 32, 11, 0x00, 48, 48 );
  TEST_VSETCFGIVL( 270, 32, 11, 0x00, 49, 48 );
  TEST_VSETCFGIVL( 271, 32, 11, 0x00, 47, 47 );

  #TEST_VSETCFGIVL( 272, 32, 12, 0xf8, 15, 15 );
  #TEST_VSETCFGIVL( 273, 32, 12, 0xf8, 16, 15 );
  #TEST_VSETCFGIVL( 274, 32, 12, 0xf8, 14, 14 );

  TEST_VSETCFGIVL( 275, 32, 12, 0x00, 40, 40 );
  TEST_VSETCFGIVL( 276, 32, 12, 0x00, 41, 40 );
  TEST_VSETCFGIVL( 277, 32, 12, 0x00, 39, 39 );

  #TEST_VSETCFGIVL( 278, 32, 13, 0xf8, 15, 15 );
  #TEST_VSETCFGIVL( 279, 32, 13, 0xf8, 16, 15 );
  #TEST_VSETCFGIVL( 280, 32, 13, 0xf8, 14, 14 );

  TEST_VSETCFGIVL( 281, 32, 13, 0x00, 40, 40 );
  TEST_VSETCFGIVL( 282, 32, 13, 0x00, 41, 40 );
  TEST_VSETCFGIVL( 283, 32, 13, 0x00, 39, 39 );

  #TEST_VSETCFGIVL( 284, 32, 14, 0xf8, 15, 15 );
  #TEST_VSETCFGIVL( 285, 32, 14, 0xf8, 16, 15 );
  #TEST_VSETCFGIVL( 286, 32, 14, 0xf8, 14, 14 );

  TEST_VSETCFGIVL( 287, 32, 14, 0x00, 40, 40 );
  TEST_VSETCFGIVL( 288, 32, 14, 0x00, 41, 40 );
  TEST_VSETCFGIVL( 289, 32, 14, 0x00, 39, 39 );

  #TEST_VSETCFGIVL( 290, 32, 15, 0xf8, 15, 15 );
  #TEST_VSETCFGIVL( 291, 32, 15, 0xf8, 16, 15 );
  #TEST_VSETCFGIVL( 292, 32, 15, 0xf8, 14, 14 );

  TEST_VSETCFGIVL( 293, 32, 15, 0x00, 40, 40 );
  TEST_VSETCFGIVL( 294, 32, 15, 0x00, 41, 40 );
  TEST_VSETCFGIVL( 295, 32, 15, 0x00, 39, 39 );

  #TEST_VSETCFGIVL( 296, 32, 16, 0xf8, 15, 15 );
  #TEST_VSETCFGIVL( 297, 32, 16, 0xf8, 16, 15 );
  #TEST_VSETCFGIVL( 298, 32, 16, 0xf8, 14, 14 );

  TEST_VSETCFGIVL( 299, 32, 16, 0x00, 40, 40 );
  TEST_VSETCFGIVL( 300, 32, 16, 0x00, 41, 40 );
  TEST_VSETCFGIVL( 301, 32, 16, 0x00, 39, 39 );

  #TEST_VSETCFGIVL( 302, 32, 17, 0xf8, 15, 15 );
  #TEST_VSETCFGIVL( 303, 32, 17, 0xf8, 16, 15 );
  #TEST_VSETCFGIVL( 304, 32, 17, 0xf8, 14, 14 );

  TEST_VSETCFGIVL( 305, 32, 17, 0x00, 40, 40 );
  TEST_VSETCFGIVL( 306, 32, 17, 0x00, 41, 40 );
  TEST_VSETCFGIVL( 307, 32, 17, 0x00, 39, 39 );

  #TEST_VSETCFGIVL( 308, 32, 18, 0xf8, 15, 15 );
  #TEST_VSETCFGIVL( 309, 32, 18, 0xf8, 16, 15 );
  #TEST_VSETCFGIVL( 310, 32, 18, 0xf8, 14, 14 );

  TEST_VSETCFGIVL( 311, 32, 18, 0x00, 40, 40 );
  TEST_VSETCFGIVL( 312, 32, 18, 0x00, 41, 40 );
  TEST_VSETCFGIVL( 313, 32, 18, 0x00, 39, 39 );

  #TEST_VSETCFGIVL( 314, 32, 19, 0xf8, 15, 15 );
  #TEST_VSETCFGIVL( 315, 32, 19, 0xf8, 16, 15 );
  #TEST_VSETCFGIVL( 316, 32, 19, 0xf8, 14, 14 );

  TEST_VSETCFGIVL( 317, 32, 19, 0x00, 40, 40 );
  TEST_VSETCFGIVL( 318, 32, 19, 0x00, 41, 40 );
  TEST_VSETCFGIVL( 319, 32, 19, 0x00, 39, 39 );

  #TEST_VSETCFGIVL( 320, 32, 20, 0xf8, 15, 15 );
  #TEST_VSETCFGIVL( 321, 32, 20, 0xf8, 16, 15 );
  #TEST_VSETCFGIVL( 322, 32, 20, 0xf8, 14, 14 );

  TEST_VSETCFGIVL( 323, 32, 20, 0x00, 40, 40 );
  TEST_VSETCFGIVL( 324, 32, 20, 0x00, 41, 40 );
  TEST_VSETCFGIVL( 325, 32, 20, 0x00, 39, 39 );

  #TEST_VSETCFGIVL( 326, 32, 21, 0xf8, 12, 12 );
  #TEST_VSETCFGIVL( 327, 32, 21, 0xf8, 13, 12 );
  #TEST_VSETCFGIVL( 328, 32, 21, 0xf8, 11, 11 );

  TEST_VSETCFGIVL( 329, 32, 21, 0x00, 32, 32 );
  TEST_VSETCFGIVL( 330, 32, 21, 0x00, 33, 32 );
  TEST_VSETCFGIVL( 331, 32, 21, 0x00, 31, 31 );

  #TEST_VSETCFGIVL( 332, 32, 22, 0xf8, 12, 12 );
  #TEST_VSETCFGIVL( 333, 32, 22, 0xf8, 13, 12 );
  #TEST_VSETCFGIVL( 334, 32, 22, 0xf8, 11, 11 );

  TEST_VSETCFGIVL( 335, 32, 22, 0x00, 32, 32 );
  TEST_VSETCFGIVL( 336, 32, 22, 0x00, 33, 32 );
  TEST_VSETCFGIVL( 337, 32, 22, 0x00, 31, 31 );

  #TEST_VSETCFGIVL( 338, 32, 23, 0xf8, 12, 12 );
  #TEST_VSETCFGIVL( 339, 32, 23, 0xf8, 13, 12 );
  #TEST_VSETCFGIVL( 340, 32, 23, 0xf8, 11, 11 );

  TEST_VSETCFGIVL( 341, 32, 23, 0x00, 32, 32 );
  TEST_VSETCFGIVL( 342, 32, 23, 0x00, 33, 32 );
  TEST_VSETCFGIVL( 343, 32, 23, 0x00, 31, 31 );

  #TEST_VSETCFGIVL( 344, 32, 24, 0xf8, 12, 12 );
  #TEST_VSETCFGIVL( 345, 32, 24, 0xf8, 13, 12 );
  #TEST_VSETCFGIVL( 346, 32, 24, 0xf8, 11, 11 );

  TEST_VSETCFGIVL( 347, 32, 24, 0x00, 32, 32 );
  TEST_VSETCFGIVL( 348, 32, 24, 0x00, 33, 32 );
  TEST_VSETCFGIVL( 349, 32, 24, 0x00, 31, 31 );

  #TEST_VSETCFGIVL( 350, 32, 25, 0xf8, 12, 12 );
  #TEST_VSETCFGIVL( 351, 32, 25, 0xf8, 13, 12 );
  #TEST_VSETCFGIVL( 352, 32, 25, 0xf8, 11, 11 );

  TEST_VSETCFGIVL( 353, 32, 25, 0x00, 32, 32 );
  TEST_VSETCFGIVL( 354, 32, 25, 0x00, 33, 32 );
  TEST_VSETCFGIVL( 355, 32, 25, 0x00, 31, 31 );

  #TEST_VSETCFGIVL( 356, 32, 26, 0xf8, 12, 12 );
  #TEST_VSETCFGIVL( 357, 32, 26, 0xf8, 13, 12 );
  #TEST_VSETCFGIVL( 358, 32, 26, 0xf8, 11, 11 );

  TEST_VSETCFGIVL( 359, 32, 26, 0x00, 32, 32 );
  TEST_VSETCFGIVL( 360, 32, 26, 0x00, 33, 32 );
  TEST_VSETCFGIVL( 361, 32, 26, 0x00, 31, 31 );

  #TEST_VSETCFGIVL( 362, 32, 27, 0xf8, 12, 12 );
  #TEST_VSETCFGIVL( 363, 32, 27, 0xf8, 13, 12 );
  #TEST_VSETCFGIVL( 364, 32, 27, 0xf8, 11, 11 );

  TEST_VSETCFGIVL( 365, 32, 27, 0x00, 32, 32 );
  TEST_VSETCFGIVL( 366, 32, 27, 0x00, 33, 32 );
  TEST_VSETCFGIVL( 367, 32, 27, 0x00, 31, 31 );

  #TEST_VSETCFGIVL( 368, 32, 28, 0xf8, 12, 12 );
  #TEST_VSETCFGIVL( 369, 32, 28, 0xf8, 13, 12 );
  #TEST_VSETCFGIVL( 370, 32, 28, 0xf8, 11, 11 );

  TEST_VSETCFGIVL( 371, 32, 28, 0x00, 32, 32 );
  TEST_VSETCFGIVL( 372, 32, 28, 0x00, 33, 32 );
  TEST_VSETCFGIVL( 373, 32, 28, 0x00, 31, 31 );

  #TEST_VSETCFGIVL( 374, 32, 29, 0xf8, 12, 12 );
  #TEST_VSETCFGIVL( 375, 32, 29, 0xf8, 13, 12 );
  #TEST_VSETCFGIVL( 376, 32, 29, 0xf8, 11, 11 );

  TEST_VSETCFGIVL( 377, 32, 29, 0x00, 32, 32 );
  TEST_VSETCFGIVL( 378, 32, 29, 0x00, 33, 32 );
  TEST_VSETCFGIVL( 379, 32, 29, 0x00, 31, 31 );

  #TEST_VSETCFGIVL( 380, 32, 30, 0xf8, 12, 12 );
  #TEST_VSETCFGIVL( 381, 32, 30, 0xf8, 13, 12 );
  #TEST_VSETCFGIVL( 382, 32, 30, 0xf8, 11, 11 );

  TEST_VSETCFGIVL( 383, 32, 30, 0x00, 32, 32 );
  TEST_VSETCFGIVL( 384, 32, 30, 0x00, 33, 32 );
  TEST_VSETCFGIVL( 385, 32, 30, 0x00, 31, 31 );

  #TEST_VSETCFGIVL( 386, 32, 31, 0xf8, 12, 12 );
  #TEST_VSETCFGIVL( 387, 32, 31, 0xf8, 13, 12 );
  #TEST_VSETCFGIVL( 388, 32, 31, 0xf8, 11, 11 );

  TEST_VSETCFGIVL( 389, 32, 31, 0x00, 32, 32 );
  TEST_VSETCFGIVL( 390, 32, 31, 0x00, 33, 32 );
  TEST_VSETCFGIVL( 391, 32, 31, 0x00, 31, 31 );

  #TEST_VSETCFGIVL( 392, 32, 32, 0xf8, 12, 12 );
  #TEST_VSETCFGIVL( 393, 32, 32, 0xf8, 13, 12 );
  #TEST_VSETCFGIVL( 394, 32, 32, 0xf8, 11, 11 );

  TEST_VSETCFGIVL( 395, 32, 32, 0x00, 32, 32 );
  TEST_VSETCFGIVL( 396, 32, 32, 0x00, 33, 32 );
  TEST_VSETCFGIVL( 397, 32, 32, 0x00, 31, 31 );

  #-------------------------------------------------------------
  # Source/Destination tests
  #-------------------------------------------------------------

  TEST_PASSFAIL

RVTEST_CODE_END

  .data
RVTEST_DATA_BEGIN

  TEST_DATA

RVTEST_DATA_END
